
/*-
 * fwl.h
 *
 *	@(#)fwl.h	1.4 (UCLA Ficus Project) 1/30/95
 *
 * Copyright (c) 1994 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifdef I_FWL


/*
 * VFS_MOUNT: flag to go in vfsp->vfs_flag
 * (should go in vfs.h)
 * indicates that xfs_mount should do fwls.
 * (This is kind of a hack.  A better solution
 * would be to have all mounts always do fwls.)
 */
#define VFS_FWL 0x800
/*
 * The FWL mount.  Another, similar hack.
 * Arugment list games.
 */
#define VFS_FWL_MOUNT(VFSP, PATH, DATA, FWLS) \
	(*(VFSP)->vfs_op->vfs_mount)(VFSP, PATH, DATA, FWLS)


#define FWL_OP_DOUBLES 1

/*
 * Note that opve_impl and opve_doubled_op could be a union
 * (or a void*)
 * but they aren't to allow compile time initialization.
 */
struct fwl_vnodeopv_entry_desc {
	struct vnodeop_desc *opve_op;   /* which operation this is */
	int (*opve_impl)();	/* code implementing this operation */
	int opve_flags;
	struct vnodeop_desc *opve_doubled_op;
};

struct fwl_mount_desc {
	char *fwlm_name;
	struct fwl_vnodeopv_entry_desc *fwlm_vopv_entries;
};


#include <i405/FWL/fwl_conf.h>
#include <i405/FWL/fwl_subr.h>
#include <i405/FWL/fwl_syscalls.h>
#include <i405/FWL/fwl_interface.h>


#endif /* I_FWL */
