
/*-
 * fwl_conf.c
 *
 *	@(#)fwl_conf.c	1.5 (UCLA Ficus Project) 5/8/95
 *
 * Copyright (c) 1994,1995 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifdef I_FWL

#include <sys/param.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <i405/i405.h>


/*
 * Manually include new layers header files here.
 */
#include <i405/FWL/oldtonew_vnodeops.h>
#include <i405/FWL/vmio_vnodeops.h>
#include <i405/FWL/specref_vnodeops.h>
#include <i405/FWL/pathconf_vnodeops.h>
#include <i405/FWL/frl_vnodeops.h>
#include <i405/FWL/maptostackmap_vnodeops.h>
#include <i405/FWL/fdnlc_vnodeops.h>
#include <i405/FWL/fsync_vnodeops.h>
#include <i405/FWL/ro_vnodeops.h>

/*
 * fwl_mount_descs is the equivilent of the mount table,
 * but for FWLs.
 */
struct fwl_mount_desc fwl_mount_descs[] = {
{ "oldtonew", oldtonew_fwl_vnodeop_entries },
{ "vmio", vmio_fwl_vnodeop_entries },
{ "specref", specref_fwl_vnodeop_entries },
{ "pathconf", pathconf_fwl_vnodeop_entries },
{ "frl", frl_fwl_vnodeop_entries },
{ "maptostackmap", maptostackmap_fwl_vnodeop_entries },
{ "fdnlc", fdnlc_fwl_vnodeop_entries },
{ "fsync", fsync_fwl_vnodeop_entries },
{ "ro", ro_fwl_vnodeop_entries },
{ NULL, NULL },
};
#endif /* I_FWL */
