
/*-
 * oldtonew_vnodeops.c
 *
 *	@(#)oldtonew_vnodeops.c	1.4 (UCLA Ficus Project) 1/30/95
 *
 * Copyright (c) 1994 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifdef I_FWL

#include <sys/param.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <i405/i405.h>
#include <sys/debug.h>   /* for ASSERT */

struct fwl_vnodeopv_entry_desc oldtonew_fwl_vnodeop_entries[] = {
	{ &old_nvop_open_desc, oldtonew_nvop_open, 0, NULL },
	{ &old_nvop_close_desc, oldtonew_nvop_close, 0, NULL },
	{ &old_nvop_rdwr_desc, oldtonew_nvop_rdwr, 0, NULL },
	{ &old_nvop_ioctl_desc, oldtonew_nvop_ioctl, 0, NULL },
	{ &old_nvop_select_desc, oldtonew_nvop_select, 0, NULL },
	{ &old_nvop_getattr_desc, oldtonew_nvop_getattr, 0, NULL },
	{ &old_nvop_setattr_desc, oldtonew_nvop_setattr, 0, NULL },
	{ &old_nvop_access_desc, oldtonew_nvop_access, 0, NULL },
	{ &old_nvop_lookup_desc, oldtonew_nvop_lookup, 0, NULL },
	{ &old_nvop_create_desc, oldtonew_nvop_create, 0, NULL },
	{ &old_nvop_remove_desc, oldtonew_nvop_remove, 0, NULL },
	{ &old_nvop_link_desc, oldtonew_nvop_link, 0, NULL },
	{ &old_nvop_rename_desc, oldtonew_nvop_rename, 0, NULL },
	{ &old_nvop_mkdir_desc, oldtonew_nvop_mkdir, 0, NULL },
	{ &old_nvop_rmdir_desc, oldtonew_nvop_rmdir, 0, NULL },
	{ &old_nvop_readdir_desc, oldtonew_nvop_readdir, 0, NULL },
	{ &old_nvop_symlink_desc, oldtonew_nvop_symlink, 0, NULL },
	{ &old_nvop_readlink_desc, oldtonew_nvop_readlink, 0, NULL },
	{ &old_nvop_fsync_desc, oldtonew_nvop_fsync, 0, NULL },
	{ &old_nvop_inactive_desc, oldtonew_nvop_inactive, 0, NULL },
	{ &old_nvop_lockctl_desc, oldtonew_nvop_lockctl, 0, NULL },
	{ &old_nvop_fid_desc, oldtonew_nvop_fid, 0, NULL },
	{ &old_nvop_getpage_desc, oldtonew_nvop_getpage, 0, NULL },
	{ &old_nvop_putpage_desc, oldtonew_nvop_putpage, 0, NULL },
	{ &old_nvop_map_desc, oldtonew_nvop_map, 0, NULL },
	{ &old_nvop_dump_desc, oldtonew_nvop_dump, 0, NULL },
	{ &old_nvop_cmp_desc, oldtonew_nvop_cmp, 0, NULL },
	{ &old_nvop_realvp_desc, oldtonew_nvop_realvp, 0, NULL },
	{ &old_nvop_cntl_desc, oldtonew_nvop_cntl, 0, NULL },
	{ NULL, NULL, 0, NULL },
};



/*-
 *--------------------------------------------------------------------------
 *
 * oldtonew_sanity_check -- make sure oldtonew really does backwards compatibility
 *
 * RETURN VALUES:
 *      None.  Panics on error.
 *
 *--------------------------------------------------------------------------
 */
void
oldtonew_sanity_check()
{
	ASSERT(VOFFSET(old_nvop_open) == 0);
	ASSERT(VOFFSET(old_nvop_close) == 1);
	ASSERT(VOFFSET(old_nvop_cntl) == 28);
}


#endif /* I_FWL */

