
/*
 * alloc.c
 *
 *	@(#)alloc.c	1.3 (UCLA Ficus Project) 9/19/94
 *
 * Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <syslog.h>
#include <errno.h>
#include <malloc.h>
#include <ficus/cdefs.h>
#include <i405/LIB/LAYER/syslog.h>

caddr_t
kmem_alloc(nbytes)
        register u_int nbytes;
{

	caddr_t p;

	if ((p=(caddr_t )malloc((unsigned)nbytes)) == NULL) {
		syslog(LOG_ERR,"malloc: err=%d\n",errno);
	}
	return p;
}


caddr_t
kmem_zalloc(nbytes)
	register u_int nbytes;
{

	caddr_t p;
	if ((p=(caddr_t )calloc((unsigned)1,(unsigned)nbytes)) == NULL) {
		syslog(LOG_ERR,"calloc: err=%d\n",errno);
	}
	return p;
}


/* ARGSUSED */
int				
kmem_free(ptr, nbytes)
        caddr_t ptr;
        u_int   nbytes;        /* Size of node to be released */
{
/* fn should be really be void, but to be consistent w/ kernel, use int */
	if (!(free(ptr)))
	syslog(LOG_ERR,"FREE: err=%d\n",errno);
	return 0;
}


