/*
 * All these includes are to define fhandle_t and enum uio_rw.
 */
#include <sys/uio.h>
#include <rpc/xdr.h>
#include <nfs/nfs.h>

/*
 * This bogoisity is to avoid compiler warnings.
 */
struct exaddrlist;
struct exportinfo;
struct ffshandle;
struct fid;
struct flnode;
struct nfsfattr;
struct proc;
struct sockaddr;
struct svc_req;
struct ucred;
struct uio;
struct vattr;
struct vfs;
struct vnode;

/*
 * miscellaneous defs not in compat.c
 */
#ifndef ficus_kernel_prototypes_h
typedef int void_but_int;

extern void_but_int bcopy __P((const void* b1, void* b2, int length));
extern void_but_int bzero __P((void *b, int length));
extern int printf __P((const char *, ...));
extern int syscall __P((int, ...));
#endif


/* 
 * compat.c defs
 */
__BEGIN_DECLS
extern int svckudp_dup __P((struct svc_req *req));
extern int svckudp_dupsave __P((struct svc_req *req));
extern int panic __P((char *s)) func_noreturn;
extern int relvm __P((struct proc *p));
extern caddr_t kmem_alloc __P((u_int nbytes));
extern caddr_t kmem_zalloc __P((u_int nbytes));
extern int kmem_free __P((caddr_t ptr, u_int nbytes));
extern caddr_t kmem_fast_alloc __P((caddr_t *base, int size, int chunks));
extern int kmem_fast_free __P((caddr_t *base, caddr_t p));
extern void vattr_null __P((struct vattr *vap));
extern int vattr_to_nattr __P((struct vattr *vap, struct nfsfattr *na));
extern struct ucred * crget __P((void));
extern void crfree __P((struct ucred *cr));
extern struct ucred * crdup __P((struct ucred *cr));
extern struct ucred * crgetcred __P((void));
extern int makefh __P((fhandle_t *fh, struct vnode *vp, struct exportinfo *exi));
extern int vfs_getnum __P((char *map, int mapsize));
extern void vfs_putnum __P((char *map, int n));
extern int vfs_fixedmajor __P((struct vfs *vfsp));
extern int vfs_add __P((struct vnode *vp, struct vfs *vfsp, int flags));
extern struct vfs * getvfs __P((void));
extern struct vnode * fhtovp __P((void *fh, struct exportinfo *exi));
extern struct exportinfo * findexport __P((fsid_t *fsid, struct fid *fid));
extern int hostinlist __P((struct sockaddr *sa, struct exaddrlist *addrs));
extern int sleep __P((caddr_t ptr, int priority));
extern void_but_int wakeup __P((caddr_t ptr));
extern int uiomove __P((caddr_t cp, int n, enum uio_rw rw, struct uio *uio));
extern struct vnode * dnlc_lookup __P((struct vnode *dvp, char *namep, struct ucred *cred));
extern void_but_int dnlc_enter __P((struct vnode *dvp, char *namep, struct vnode *vp, struct ucred *cred));
extern void_but_int dnlc_remove __P((struct vnode *dvp, char *namep));
extern void_but_int dnlc_purge __P((void));
extern int vn_open __P((char *pnamep, int seg, int filemode, int createmode, struct vnode **vpp));
extern int vn_rdwr __P((enum uio_rw rw, struct vnode *vp, caddr_t base, int len, int offset, int seg, int ioflag, int *aresid));
extern struct vnode * makenfsnode __P((void));
extern int printfhandle __P((caddr_t fh));
__END_DECLS
