
/*
 * i405_xport_proxy.c
 *
 *	@(#)i405_xport_proxy.c	1.3 (UCLA Ficus Project) 2/18/94
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <ficus/kernel_prototypes.h>

/*
 * OOK we have only xdr and alloc transport routines,
 * we do not have utok or fxdr.
 * To prevent link errors in the generic tables,
 * we define a bunch of stub routines here.
 */
int
i405_utok_indirect_implicit_array()
{
	panic ("i405_utok_indirect_implicit_array");
}

int
i405_utok_structure()
{
	panic ("i405_utok_structure");
}

int
i405_utok_fixed_array()
{
	panic ("i405_utok_fixed_array");
}

int
i405_utok_indirect_fixed_array()
{
	panic ("i405_utok_indirect_fixed_array");
}

int
i405_utok_char_p()
{
	panic ("i405_utok_char_p");
}

int
i405_utok_variable_array()
{
	panic ("i405_utok_variable_array");
}

int
i405_utok_indirect_variable_array()
{
	panic ("i405_utok_indirect_variable_array");
}

int
i405_utok_char()
{
	panic ("i405_utok_char");
}

int
i405_utok_implicit_array()
{
	panic ("i405_utok_implicit_array");
}

int
i405_utok_copy()
{
	panic ("i405_utok_copy");
}

int
i405_utok_reference()
{
	panic ("i405_utok_reference");
}

int
i405_utok_struct_vnode_p()
{
	panic ("i405_utok_struct_vnode_p");
}

int
i405_fxdr_struct_vnode_p()
{
	panic ("i405_fxdr_struct_vnode_p");
}

int
i405_utok_struct_i405_uio()
{
	panic ("i405_utok_struct_i405_uio");
}

int
i405_utok_struct_ucred_p()
{
	panic ("i405_utok_struct_ucred_p");
}

int
i405_utok_struct_ucred()
{
	panic ("i405_utok_struct_ucred");
}

int
i405_utok_struct_uio_p()
{
	panic ("i405_utok_struct_uio_p");
}

int
i405_fxdr_struct_vnode_pp()
{
	panic ("i405_fxdr_struct_vnode_pp");
}

