
/*
 * OOK Specific routines.
 *
 *	@(#)i405_ook.c	1.5 (UCLA Ficus Project) 1/12/93
 *
 * Copyright (c) 1991,1992 The Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * John Heidemann of the Ficus project at UCLA.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


#include <sys/param.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <sys/vfs.h>
#include <sys/errno.h>
#include <i405/i405.h>
#include <i405/i405_syscalls.h>

#ifdef OUTOFKERNEL


/*
 * Turn this variable on to see every in-to-kernel vnodeop printed.
 */
int user_new_vnodeop_debug = 0;

/*
 * User level interface to the new vnode operations.
 * NEEDSWORK: Bad style, uses magic syscall numbers.
 *
 * We used to dredge actual offsets out of the kernel,
 * but this became too big of a pain, so now we use uuids
 * between the user and kernel levels.
 */

int
user_new_vnodeop(vp, off, ap)
	struct vnode *vp;
	int off;
	struct nvop_generic_args *ap;
{
	struct nvop_generic_args **app = &ap;  /* YAH--yet another hack */
	int error;
	extern int errno;

	if (user_new_vnodeop_debug)
		printf ("calling vop, vp=%x, off=%d(%s), app=%x", vp, off,
			ap->a_desc->vdesc_name,
			app);
	error = syscall (SYS_user_uuid_vnodeop, vp, UCLA_TRANSPORT(ap->a_desc)->vdut_uuid, app);

	if (user_new_vnodeop_debug)
		printf (".\n");
	return (error == -1) ? errno : 0;
}

#endif
