
/*
 * Copyright (c) 1991,1992 The Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * John Heidemann of the Ficus project at UCLA.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * Universally Unique IDs for the new interface.
 *
 * It's unfortunate that these have to be in lowercase.
 * They must end in _uuid for VOFFSET to work in certain cases.
 * (The alternative is to make xvop_foo_desc uppercase, which
 * is certainly worse).
 *
 * This version is dated 21-Oct-91.
 *
 * For assignment of new operations,
 * contact <johnh@cs.ucla.edu>.
 *
 * This uuid mechanism is DEPRICATED.
 * A new mechanism using NCA UUIDs is in place
 * that allows completely decentralized uuid allocation.
 * Run i405/make_nca_uuid to allocate new ids.
 */

#if 0

#define nvop_default_smalluuid		1000

#define nvop_open_smalluuid		1001
#define nvop_close_smalluuid		1002
#define nvop_rdwr_smalluuid		1003
#define nvop_ioctl_smalluuid		1004
#define nvop_select_smalluuid		1005
#define nvop_getattr_smalluuid		1006
#define nvop_setattr_smalluuid		1007
#define nvop_access_smalluuid		1008
#define nvop_lookup_smalluuid		1009
#define nvop_create_smalluuid		1010
#define nvop_remove_smalluuid		1011
#define nvop_link_smalluuid		1012
#define nvop_rename_smalluuid		1013
#define nvop_mkdir_smalluuid		1014
#define nvop_rmdir_smalluuid		1015
#define nvop_readdir_smalluuid		1016
#define nvop_symlink_smalluuid		1017
#define nvop_readlink_smalluuid		1018
#define nvop_fsync_smalluuid		1019
#define nvop_inactive_smalluuid		1020
#define nvop_lockctl_smalluuid		1021
#define nvop_fid_smalluuid		1022
#define nvop_getpage_smalluuid		1023
#define nvop_putpage_smalluuid		1024
#define nvop_map_smalluuid		1025
#define nvop_dump_smalluuid		1026
#define nvop_cmp_smalluuid		1027
#define nvop_realvp_smalluuid		1028
#define nvop_cntl_smalluuid		1029

#define fvop_debug_smalluuid		2001
#define fvop_orphan_smalluuid		2002
#define fvop_getfattrs_smalluuid	2003
#define fvop_setfattrs_smalluuid	2004
#define fvop_newcreate_smalluuid	2005
#define fvop_newrename_smalluuid     	2006
#define fvop_newremove_smalluuid     	2007
#define fvop_replidalloc_smalluuid	2008
#define fvop_addentry_smalluuid		2009
#define fvop_openshadow_smalluuid	2010
#define fvop_commitshadow_smalluuid	2011
#define fvop_removeshadow_smalluuid	2012
#define fvop_ffshlook_smalluuid		2013
#define fvop_ffshremove_smalluuid	2014
#define fvop_openqueue_smalluuid	2015
#define fvop_openunnamed_smalluuid	2016
#define fvop_propdirentry_smalluuid	2017
#define fvop_upddirentry_smalluuid	2018
#define fvop_remdirentry_smalluuid	2019
#define fvop_propfile_smalluuid		2021
#define fvop_proprename_smalluuid	2022
#define fvop_propsymlink_smalluuid	2023
#define fvop_control_smalluuid		2024
#define fvop_dropvolcache_smalluuid	2025
#define fvop_readunnamed_smalluuid	2026
#define fvop_makeunnamedentry_smalluuid 2027
#define fvop_cntl_smalluuid 		2028
#define fvop_newrename_rat_smalluuid	2029
#define fvop_proprename_rat_smalluuid 	2030

#define nvop_newopen_smalluuid		3001
#define nvop_newfid_smalluuid		3002
#define nvop_purge_cache_smalluuid	3003
#define nvop_get_token_smalluuid	3004
#define nvop_newfid_to_vp_smalluuid	3005
#define nvop_newgetpage_smalluuid	3006   /* perhaps newget_tom's_collin_page */
#define nvop_newputpage_smalluuid	3007
#define nvop_lock_smalluuid		3008 
#define nvop_unlock_smalluuid		3009
#define nvop_bogus_smalluuid		3010 	/* temporary bogus operation for Irina */

/*
 * BSD Vnode operations.
 * Currently these are a completely separate from the Sun ops.
 * This is partly because the BSD ops all have proc appended.
 */
#if 0
#define nvop_bsd_lookup_smalluuid	4001
#define nvop_bsd_create_smalluuid	4002
#define nvop_bsd_mknod_smalluuid	4003
#define nvop_bsd_open_smalluuid		4004
#define nvop_bsd_close_smalluuid	4005
#define nvop_bsd_access_smalluuid	4006
#define nvop_bsd_getattr_smalluuid	4007
#define nvop_bsd_setattr_smalluuid	4008
#define nvop_bsd_read_smalluuid		4009
#define nvop_bsd_write_smalluuid	4010
#define nvop_bsd_ioctl_smalluuid	4011
#define nvop_bsd_select_smalluuid	4012
#define nvop_bsd_mmap_smalluuid		4013
#define nvop_bsd_fsync_smalluuid	4014
#define nvop_bsd_seek_smalluuid		4015
#define nvop_bsd_remove_smalluuid	4016
#define nvop_bsd_link_smalluuid		4017
#define nvop_bsd_rename_smalluuid	4018
#define nvop_bsd_mkdir_smalluuid	4019
#define nvop_bsd_rmdir_smalluuid	4020
#define nvop_bsd_symlink_smalluuid	4021
#define nvop_bsd_readdir_smalluuid	4022
#define nvop_bsd_readlink_smalluuid	4023
#define nvop_bsd_abortop_smalluuid	4024
#define nvop_bsd_inactive_smalluuid	4025
#define nvop_bsd_reclaim_smalluuid	4026
#define nvop_bsd_lock_smalluuid		4027
#define nvop_bsd_unlock_smalluuid	4028
#define nvop_bsd_bmap_smalluuid		4029
#define nvop_bsd_strategy_smalluuid	4030
#define nvop_bsd_print_smalluuid	4031
#define nvop_bsd_islocked_smalluuid	4032
#define nvop_bsd_advlock_smalluuid	4033
#endif

#endif
