
/*
 * This is a dumping ground for the xdruser extensions and
 * some i405 stuff.  So sue me.
 */


#ifndef _XXDR_H_
#define _XXDR_H_



/*
 * xxdr stuff
 */
#include <rpc/xdr.h>

#define I405_MAXSTRLEN (256)   /* all strings are this long (sigh) */

extern bool_t xdr_alt_short();
#define xdr_alt_u_short xdr_alt_short


#define USES_PRINTOFF u_int ioff=XDR_GETPOS(xdrs), noff;
#define PRINTOFF noff=XDR_GETPOS(xdrs); printf("offset is %d\n", noff-ioff);
#define PRINTSKIP printf ("pad is %d\n", PAD);


#if 0
/*
 * F's don't check for XXDR_LINEAR (deprecated).
 */
#define FXXDR_PUSH(XDRS,ADDR) (xdruser_push(XDRS,ADDR))
#define FXXDR_POP(XDRS) (xdruser_pop(XDRS))
#define FXXDR_GETSTRING(XDRS,CP,SZ) \
	(xdruser_getstring(XDRS,CP,SZ)
#define FXXDR_SKIP(XDRS,S) (xdruser_skip(XDRS,S))
#endif



#ifdef OUTOFKERNEL

#define XXDR_LINEAR(XDRS) (TRUE)
#define XXDR_PUSH(XDRS,ADDR) (TRUE)
#define XXDR_POP(XDRS) (TRUE)
#define XXDR_GETSTRING(XDRS,CP,SZ) (FALSE)
#define XXDR_SKIP(XDRS,S) (TRUE)

#else

#define XXDR_LINEAR(XDRS) ((XDRS)->x_ops != xdruser_ops)
#define XXDR_PUSH(XDRS,ADDR) (!XXDR_LINEAR(XDRS) ? xdruser_push(XDRS,ADDR) : TRUE)
#define XXDR_POP(XDRS) (!XXDR_LINEAR(XDRS) ? xdruser_pop(XDRS) : TRUE)
#define XXDR_GETSTRING(XDRS,CP,SZ) \
	(!XXDR_LINEAR(XDRS) ? xdruser_getstring(XDRS,CP,SZ) : FALSE)
#define XXDR_SKIP(XDRS,S) ((!XXDR_LINEAR(XDRS)) ? (xdruser_skip(XDRS,S)) : TRUE)

#endif



/*
 * xdruser stuff.
 */

#define XDRUSER_DEPTH 8

extern struct xdr_ops *xdruser_ops;




/*
 * nvop stuff
 */

#if defined(KERNEL)

#ifndef OUTOFKERNEL
extern bool_t xdr_vptofd(), xdr_fdtovp(), xdr_fdvpfree(), xdr_fdvpp_stuff();
#endif OUTOFKERNEL
extern bool_t xdr_vptofh(), xdr_fhtovp(), xdr_fhvpfree(),
	 xdr_vpptofh(), xdr_fhtovpp(), xdr_fhvppfree();

#endif KERNEL

/*
 * in - get arguments
 * out - send results
 * space - like in, but only get space for arrays and data structures.
 */
enum xfer_direction { xfer_in, xfer_out, xfer_space };

struct nvop_xdr_public {
	int (*freefunc)();   /*
			      * This is here because svckudp_send expects it.
			      * See the comment in lib/libc/rpc/svc_kudp.c's
			      * svckudp_send.
			      */
	enum xfer_direction mode;
	bool_t (*otw_to_vp)();
	bool_t (*vp_to_otw)();
	bool_t (*vp_free)();
	struct exportinfo *exi;/* needed to do fh->vp mapping, null otherwise */
	bool_t (*otw_to_vpp)();   /* more hackery... */
	bool_t (*vpp_to_otw)();
	bool_t (*vpp_free)();
	struct vfs *vfsp;   /* needed for fh->vpp mapping, null otherwise */
	XDR *xdrs;   /* needed to get data into rfsbypassfree */
};

#define NVOP_PUBLIC(XDRS) ((struct nvop_xdr_public*)((XDRS)->x_public))
#define XXDR_GETMODE(XDRS) (NVOP_PUBLIC(XDRS)->mode)
#define XXDR_IN(XDRS) (XXDR_GETMODE(XDRS) == xfer_in)
#define XXDR_OUT(XDRS) (XXDR_GETMODE(XDRS) == xfer_out)
#define XXDR_SPACE(XDRS) (XXDR_GETMODE(XDRS) == xfer_space)
#define XXDR_SETMODE(XDRS, MODE) NVOP_PUBLIC(XDRS)->mode = MODE

#endif

