#ifndef svcm_vm__ah_h
#define svcm_vm__ah_h
/*-
 * svcm_vm__ah.h
 *
 *	@(#)updateheader	1.14 (UCLA Ficus Project) 7/27/94
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


/*
 * NOTE:
 * The file is automatically maintained via the program updateheader.
 * While additions to this file will be maintained, there is no need to
 * edit the function prototypes for functions in svcm_vm.c
 * --- they will be automatically updated.
 */

__BEGIN_DECLS
#ifdef SVCM_TWO
extern int i405_vn_map __P((struct nvop_map_args *ap));
extern int pvn_stackgetpages __P((PFI getapage, struct vnode *vp, struct svcm_name *name, struct vnode *mapvp, u_int off, u_int len, u_int *protp, struct page **pl, u_int plsz, struct seg *seg, addr_t addr, enum seg_rw rw, struct ucred *cred));
extern void pvn_dump_pages_with_text __P((struct vnode *vp, int text_count));
extern void pvn_dump_pages __P((struct vnode *vp));
extern void pvn_verify_page_owner __P((struct vnode *vp));
extern void i405_vm_verify_pagelist_owner __P((struct page **pl, u_int plsz, struct vnode *vp));
#ifdef SVCM_PAGEFLIP
extern int page_unenter __P((struct page *pp));
extern int page_flip __P((struct page *pp, struct vnode *mapvp));
extern struct page * page_ioless_lookup __P((struct vnode *vp, u_int off));
extern int svcm_pageflip_byterange __P((struct svcm_name *name, struct vnode *srcvp, struct vnode *destvp, u_int off, u_int len));
extern int svcm_pageflip_all __P((struct svcm_name *name, struct vnode *srcvp, struct vnode *destvp));
extern struct page * pvn_stackkluster __P((struct vnode *physvp, struct svcm_name *name, struct vnode *mapvp, u_int off, struct seg *seg, addr_t addr, u_int *offp, u_int *lenp, u_int mapvp_off, u_int mapvp_len, int isra, struct ucred *cred));
#endif /* SVCM_PAGEFLIP */
#endif /* SVCM_TWO */
__END_DECLS

#endif /* svcm_vm__ah_h */
