
/*
 * map_and_rdwr.c
 *
 * This tests concurrent mmaping and read/writing.
 */


#include <sys/types.h>
#include <sys/mman.h>
#include <sys/fcntl.h>
#include <sys/unistd.h>

char *file;

main(argc, argv)
	int argc;
	char **argv;
{
	int fd;
	char *raddr, *addr, *mmap();
	static char buf[100];

	if (argc != 2) {
		printf ("%s FILENAME\n", argv[0]);
		exit (1);
	};
	file = argv[1];

	unlink(file);
	if (-1==(fd = open(file, O_RDWR|O_CREAT, 0666))) {
		perror ("open");
		exit(1);
	};
	if (-1==ftruncate (fd, 3)) {
		perror ("ftruncate");
		exit (1);
	};
	if (-1==write (fd, buf, 3)) {
		perror ("write");
		exit (1);
	};
	fsync(fd);
	raddr = addr = 0;
	if (-1==(int)(raddr = mmap(addr, 3, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0))) {
		perror ("mmap");
		exit(1);
	};

	raddr[0] = 'a';
	lseek (fd, 1, SEEK_SET);
	buf[0] = 'b';
	write (fd, buf, 1);
	raddr[2] = 'c';

	close (fd);




	sync();

	if (-1==(fd = open(file, O_RDWR|O_CREAT, 0666))) {
		perror ("open");
		exit(1);
	};

	if (-1==read (fd, buf, 3)) {
		perror ("read");
		exit(1);
	};
	printf ("read back: %c,%c,%c  %x,%x,%x\n", 
		buf[0], buf[1], buf[2],
		buf[0], buf[1], buf[2]);

	close (fd);
	if (buf[0] != 'a' && buf[1] != 'b' && buf[2] != 'c') {
		printf ("   bad storage.\n");
	};
	
}
