 
#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/fcntl.h>
#include <sys/stat.h>

int
main(argc, argv)
	int argc;
	char **argv;
{
	char *raddr, *addr;
	int fd;
	int off = 0;
	int count, size;
	int i;
	char *file, *mmap();
	struct stat sb;
	int check =0;

	if (argc < 3) {
		printf ("Usage: [-c (check for zero pages)] file size [write-count].\n");
		exit (1);
	};

	i=1;
	if (strcmp(argv[i],"-c")==0) {
		check = 1;
		i++;
	};
	file = argv[i];
	size = atoi(argv[i+1]);
	if (i < argc) {
		count = atoi(argv[i+2]);
	} else {
		count = size;
	};

	printf ("File <%s>, size %d, count %d\n", file, size, count);
	if (-1==(fd = open(file, O_RDWR|O_CREAT, 0666))) {
		perror ("open");
		exit(1);
	};
	if (-1==fstat (fd, &sb)) {
		perror ("fstat");
		exit (1);
	};
	if (sb.st_size < size) {   /* mmaping fails if beyond eof */
#if 0
		if (-1==ftruncate (fd, size)) {
			perror ("ftruncate");
			exit (1);
		};
#else
		printf ("file size too small, map will fail.\n");
		exit (1);
#endif
	};
	raddr = addr = 0;
	if (-1==(int)(raddr = mmap(addr, size, PROT_READ|PROT_WRITE, MAP_SHARED, fd, off))) {
		perror ("mmap");
		exit(1);
	};
	printf ("raddr = %x\n", (unsigned int)raddr);
#define SPOTS (0x7f-' ')
#define OFFSET (' ')
	for (i=0; i<size; i++) {
		if (check && raddr[i]) {
			fprintf (stderr, "non-zeroed data %c/%d, offset %d\n", raddr[i], raddr[i], i);
		};
		if (i < count)
			raddr[i] = (i % SPOTS) + OFFSET;
	};
	close (fd);
	exit (0);
}

