
/*
 * newfid.c
 *
 * KERNEL, OUTOFKERNEL, STANDALONE_OOK are defined in the Makefile.
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <i405/i405.h>
#include <sys/param.h>

#include <newofs/newo_interface.h>

#include <sys/fcntl.h>


int
main(argc, argv)
	int argc;
	char **argv;
{
	struct vnode *vp;
	USES_NVOP_NEWFID;
	int offset;
	int error,i;
	struct newfid newfid;
#define DATASPACE 128
	static u_char newfiddata[DATASPACE];

	if (argc!=2) {
		printf ("usage: %s filename \n", argv[0]);
		exit (1);
	};

	if (error = ook_vn_open(argv[1], &vp)) {
		perror ("vn_open");
		exit (1);
	};

	newfid.newfid_data = newfiddata;
	newfid.newfid_data_space = DATASPACE;
	newfid.newfid_data_elems = 0;

	if (error = NVOP_NEWFID (vp, &newfid, NULL)) {
		perror ("getvattr");
		exit (1);
	};

	printf ("%d:", newfid.newfid_data_elems);
	for (i=0; i<newfid.newfid_data_elems; i++)
		printf ("%.2x,", (unsigned char)(newfid.newfid_data[i]));
	printf ("\n");
	
	exit (0);
}

