
/*
 * Ficus debug: send a debug message to ficus.
 *
 * KERNEL, OUTOFKERNEL, STANDALONE_OOK are defined in the Makefile.
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <newvint/newvint.h>
#include <sys/param.h>

#include <newvint/newvint_uuids.h>
#include <newofs/newo_interface.h>

#include <sys/fcntl.h>


main(argc, argv)
	int argc;
	char **argv;
{
	struct vnode *vp;
	USES_NVOP_PURGE_CACHE;
	int offset;
	int error, i;
	struct vattr  va;

	if (argc!=2) {
		printf ("usage: %s FileName \n", argv[0]);
		exit (1);
	};


	if (error = ook_vn_open(argv[1], &vp)) {
		perror ("vn_open");
		exit (1);
	};

	if (error = NVOP_PURGE_CACHE (vp, LAYERID_NFS, NULL)) {
		perror ("nfs_purge_cache");
		exit (1);
	};
}

