

#define NULL ((void*)0)

#include <sys/types.h>
#include <sys/time.h>
#include <sys/vnode.h>
 
#include <rpc/types.h>
#include <rpc/xdr.h>
#include <netinet/in.h>

#include <rpc/types.h>
#include <rpc/xdr.h>
#include <newvint/xxdr.h>


copyin(a, b, size)
	char *a, *b;
	int size;
{
	bcopy (a, b, size);
	return 0;
}
copyout(a, b, size)
	char *a, *b;
	int size;
{
	bcopy (a, b, size);
	return 0;
}

copyinstr()
{
	printf ("copyinstr\n");
	return -1;
}

char *
kmem_alloc(n)
	int n;
{
	extern char *malloc();
	return malloc(n);
}

bool_t
xdr_struct_timeval(xdrs, p)
        register XDR *xdrs;
        struct timeval *p;            /* the pointer to work on */
{
	return (xdr_long(xdrs, &p->tv_sec) &&
		xdr_long(xdrs, &p->tv_usec)) ? TRUE : FALSE;
}

bool_t
xdr_alt_reference(xdrs, pp, size, proc)
	register XDR *xdrs;
	caddr_t *pp;		/* the pointer to work on */
	u_int size;		/* size of the object pointed to */
	xdrproc_t proc;		/* xdr routine to handle the object */
{
	caddr_t userp;
	register caddr_t loc = *pp;
	register bool_t stat;
	bool_t needpop=FALSE;

	if (loc == NULL)
		switch (xdrs->x_op) {
		case XDR_FREE:
			return (TRUE);

		case XDR_DECODE:
			*pp = loc = (caddr_t) mem_alloc(size);
#ifndef KERNEL
			if (loc == NULL) {
				(void) printf(
				    "xdr_reference: out of memory\n");
				return (FALSE);
			}
			bzero(loc, (int)size);
#else
			bzero(loc, size);
#endif
			break;
	}

	if (xdrs->x_op!=XDR_FREE && !XXDR_LINEAR(xdrs)) {
		if (!XDR_GETLONG(xdrs, &userp))
			return FALSE;
		needpop = TRUE;
		if (!XXDR_PUSH(xdrs, userp))
			return FALSE;
	};

	stat = (*proc)(xdrs, loc /*, LASTUNSIGNED */);

	if (needpop)
		XXDR_POP(xdrs);

	if (xdrs->x_op == XDR_FREE) {
		mem_free(loc, size);
		*pp = NULL;
	}
	return (stat);
}



/*
 * A short xdr that takes 16 bits when using xdr_user.
 */
bool_t
xdr_alt_short(xdrs, sp)
	XDR *xdrs;
{
	if (XXDR_LINEAR(xdrs)) {
		return xdr_short(xdrs, sp);
	}
	else switch (xdrs->x_op) {
	case XDR_ENCODE: return XDR_PUTBYTES(xdrs, sp, sizeof(short)); break;
	case XDR_DECODE: return XDR_GETBYTES(xdrs, sp, sizeof(short)); break;
	};
	return TRUE;
}
 

main()
{
	struct vattr va, va2;
	XDR xdr;
	caddr_t xdrbuf[12];
	struct nvop_xdr_public public;

	va.va_type = VDIR;
	va.va_mode = 1;
	va.va_uid = 2;
	va.va_gid = 3;
	va.va_fsid = 4;
	va.va_nodeid = 5;
	va.va_nlink = 6;
	va.va_size = 7;
	va.va_blocksize = 8;
	va.va_rdev = 9;
	va.va_blocks = 10;

	xdruser_create(&xdr, &va, xdrbuf, 6, XDR_DECODE);
	public.mode = xfer_in;
#if 0
	public.freefunc = dummy_freefunc;
	public.otw_to_vp = xdr_fdtovp;
	public.vp_to_otw = xdr_vptofd;
	public.vp_free = xdr_fdvpfree;
	public.otw_to_vpp = 
		public.vpp_to_otw = 
		public.vpp_free = xdr_fdvpp_stuff;
#endif
	xdr.x_public = (caddr_t)&public;

	if (!xdr_struct_vattr (&xdr, &va2)) {
		printf ("False.\n");
	} else {
		printf ("True.\n");
	};

	printf ("xxdr_linear: %d\n", XXDR_LINEAR(&xdr));
XXDR_SKIP(&xdr, 4);
	printf ("va_type: %d\n", va2.va_type);
	printf ("va_mode: %d\n", va2.va_mode);
	printf ("va_uid: %d\n", va2.va_uid);
	printf ("va_gid: %d\n", va2.va_gid);
	printf ("va_fsid: %d\n", va2.va_fsid);
	printf ("va_nodeid: %d\n", va2.va_nodeid);
	printf ("va_nlink: %d\n", va2.va_nlink);
	printf ("va_size: %d\n", va2.va_size);
	printf ("va_blocksize: %d\n", va2.va_blocksize);
	printf ("va_rdev: %d\n", va2.va_rdev);
	printf ("va_blocks: %d\n", va2.va_blocks);
}
