
/*
 * union_test.c
 *
 *	@(#)union_test.c	1.2 (UCLA Ficus Project) 10/25/93
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <i405/i405.h>
#include <i405/i405_test_interface.h>
#include <sys/param.h>

#include <sys/fcntl.h>

/*
 * Including this next line here is a hack:
 * we expect it to be in a library if this was for real
 * and not a test operation.
 */
struct nca_uuid fvop_i405_union_test_uuid = { 0x2c56f417, 0x00000000, 0x02, 0x83, 0xb3, 0xc0, 0x45, 0x00, 0x00, 0x00 };   /* DECLARE_UUID */


int
main(argc, argv)
	int argc;
	char **argv;
{
	struct vnode *vp;
	USES_FVOP_I405_UNION_TEST;
	int error;
	struct i405_union_test_union iutu;
	static struct i405_union_test_one i405_union_test_one = { 11, 12 };
	static struct i405_union_test_two i405_union_test_two = { {'a', 'b', 'c', 0}, 22 };

	if (argc != 2) {
		printf ("usage: %s filename \n", argv[0]);
		exit (1);
	};

	if (error = ook_vn_open(argv[1], &vp)) {
		perror ("vn_open");
		exit (1);
	};

	iutu.tag = i405_union_test_one_tag;
	iutu.un.one = i405_union_test_one;
	if (error = FVOP_I405_UNION_TEST (vp, &iutu)) {
		perror ("fvop_i405_union_test");
		exit (1);
	};

	iutu.tag = i405_union_test_two_tag;
	iutu.un.two = i405_union_test_two;
	if (error = FVOP_I405_UNION_TEST (vp, &iutu)) {
		perror ("fvop_i405_union_test");
		exit (1);
	};

	exit (0);
}


