
/*
 * i405_backvint.c
 *
 *	@(#)i405_backvint.c	1.5 (UCLA Ficus Project) 9/19/94
 *
 * Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#include <sys/param.h>
#include <sys/time.h>
#include <sys/vnode.h>
#include <i405/i405.h>


#if 0
#define DODEBUG(A) A
#else
#define DODEBUG(A)
#endif


extern int num_back_operations;

struct vnodeops oldtonew_vnodeops = {
	oldtonew_nvop_open,
	oldtonew_nvop_close,
	oldtonew_nvop_rdwr,
	oldtonew_nvop_ioctl,
	oldtonew_nvop_select,
	oldtonew_nvop_getattr,
	oldtonew_nvop_setattr,
	oldtonew_nvop_access,
	oldtonew_nvop_lookup,
	oldtonew_nvop_create,
	oldtonew_nvop_remove,
	oldtonew_nvop_link,
	oldtonew_nvop_rename,
	oldtonew_nvop_mkdir,
	oldtonew_nvop_rmdir,
	oldtonew_nvop_readdir,
	oldtonew_nvop_symlink,
	oldtonew_nvop_readlink,
	oldtonew_nvop_fsync,
	oldtonew_nvop_inactive,
	oldtonew_nvop_lockctl,
	oldtonew_nvop_fid,
	oldtonew_nvop_getpage,
	oldtonew_nvop_putpage,
	oldtonew_nvop_map,
	oldtonew_nvop_dump,
	oldtonew_nvop_cmp,
	oldtonew_nvop_realvp,
	oldtonew_nvop_cntl,
};

int num_back_operations = sizeof(struct vnodeops)/sizeof(int (*)());

