
/*
 * i405_fxdr_xport.c
 *
 *	@(#)i405_fxdr_xport.c	2.1 (UCLA Ficus Project) 9/28/93
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <sys/types.h>
#include <sys/errno.h>
#include <rpc/types.h>
#include <rpc/xdr.h>
#include <sys/param.h>
#include <sys/ucred.h>
#include <sys/vfs.h>
#include <sys/vnode.h>
#include <i405/i405.h>
#include <i405/i405_transport.h>
#include <nfs/nfs.h>
#include <sys/vfs.h>
#include <nfs/export.h>
#include <nfs/rnode.h>   /* for vtofh */
#ifdef OUTOFKERNEL
#include <i405/ook_compat.h>
#endif



#if 0
#define DODEBUG(A) A
#else
#define DODEBUG(A)
#endif


int
i405_fxdr_struct_vnode_p(there, vp_p, what_d, how, why)
	void *there;   /* IN */
	struct vnode **vp_p; /* INOUT (depends on the how argument) */
	struct xport_datatype *what_d;   /* IN */
	int how;       /* IN */
	int why;       /* IN */
{
	if (WHY_IN_P(why)) {
		if (WHY_ENCODE_P(why)) {
			return i405_fxdr_vptofh(there, vp_p);
		} else if (WHY_DECODE_P(why)) {
			return i405_fxdr_fhtovp(there, vp_p);
		};
	};
	if (WHY_ALLOC_P(why))
		return 0;
	if (WHY_FREE_P(why))
		return i405_fxdr_fhvpfree(vp_p);
	if (WHY_OUT_P(why))
		panic("i405_fxdr_struct_vnode_p: vnode innn OUT mode.");
	panic("i405_fxdr_struct_vnode_p");
}

int
i405_fxdr_struct_vnode_pp(there, vpp_p, what_d, how, why)
	void *there;   /* IN */
	struct vnode ***vpp_p; /* INOUT (depends on the how argument) */
	struct xport_datatype *what_d;   /* IN */
	int how;       /* IN */
	int why;       /* IN */
{
	if (WHY_OUT_P(why)) {
		if (WHY_ENCODE_P(why)) {
			return i405_fxdr_vpptofh(there, vpp_p);
		} else if (WHY_DECODE_P(why)) {
			return i405_fxdr_fhtovpp(there, vpp_p);
		};
	};
	if (WHY_ALLOC_P(why)) {
		if (*vpp_p == NULL)
			*vpp_p=(struct vnode**)
				mem_alloc(sizeof(struct vnode**));
		**vpp_p = NULL;   /* zero the vpp */
		return 0;
	};
	if (WHY_FREE_P(why)) {
		/*
		 * This routine will free the pointer we allocated above.
		 */
		return i405_fxdr_fhvppfree(vpp_p);
	};
	if (WHY_IN_P(why))
		panic("i405_fxdr_struct_vnode_pp: vnode in IN mode.");
	panic("i405_fxdr_struct_vnode_pp");
}


