
/*
 * This file contains routine stubs to 
 * make nfs_server.c compile properly.
 *
 *  5-Feb-91 - Stolen from ficus/misc/compat.c - JSH
 */


/* LINTLIBRARY */
#include <sys/param.h>
#include <sys/user.h>
#include <sys/vfs.h>
#include <sys/vnode.h>
#include <i405/i405.h>
#include <sys/file.h>
#include <sys/pathname.h>
#include <sys/uio.h>
#include <sys/ucred.h>
#include <sys/dnlc.h>
#include <sys/socketvar.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <rpc/types.h>
#include <rpc/auth.h>
#include <rpc/auth_unix.h>
#include <rpc/auth_des.h>
#include <rpc/svc.h>
#include <rpc/xdr.h>
#include <nfs/nfs.h>
#include <nfs/export.h>
#include <syslog.h>
#include <strings.h>



#undef freefid
#define freefid(fidp)  kmem_free((caddr_t)(fidp),sizeof(struct fid))


struct user _uunix;
struct user *uunix = &_uunix;

char *malloc();
char *calloc();


/*ARGSUSED*/
svckudp_dup(req)
	struct svc_req *req;
{
	return 0;
}

/*ARGSUSED*/
svckudp_dupsave(req)
	struct svc_req *req;
{
}

void
panic(s)
        char *s;
{
	char *crash=NULL;

	printf ("panic: %s", s);
	syslog(LOG_ERR, "panic: %s", s);
	*crash = 'a';	/* force core dump */
	exit(1);
}

relvm(p)
	struct proc *p;
{
	return 0;
}

caddr_t
kmem_alloc(nbytes)
        register u_int nbytes;
{

	caddr_t p;

	if ((p=(caddr_t )malloc((unsigned)nbytes)) == NULL) {
		syslog(LOG_ERR,"malloc: err=%d\n",errno);
	}
	return p;
}


caddr_t
kmem_zalloc(nbytes)
	register u_int nbytes;
{

	caddr_t p;
	if ((p=(caddr_t )calloc((unsigned)1,(unsigned)nbytes)) == NULL) {
		syslog(LOG_ERR,"calloc: err=%d\n",errno);
	}
	return p;
}


/* ARGSUSED */
kmem_free(ptr, nbytes)
        caddr_t ptr;
        u_int   nbytes;        /* Size of node to be released */
{
	if (!(free(ptr)))
	syslog(LOG_ERR,"FREE: err=%d\n",errno);
}



/*
 * The following 2 routines were taken verbatim from os/heap_kmem.c
 */
caddr_t
kmem_fast_alloc(base, size, chunks)
        caddr_t *base;  /* holds linked list of freed items */
        int     size;   /* size of each item - constant for given base */
        int     chunks; /* number of items to alloc when needed */
{
        caddr_t p;

        if (*base == 0) {       /* no free chunks */
                p = kmem_alloc((u_int)(size * chunks));
                while (--chunks >= 0) {
                        kmem_fast_free(base, p + chunks * size);
                }
        }
        p = *base;
        *base = *(caddr_t *)p;
        return (p);
}

kmem_fast_free(base, p)
        caddr_t *base, p;
{

        *(caddr_t *)p = *base;
        *base = p;
}

int splimp()
{
	return 0;
}

/* ARGSUSED */
int splx(s)
	int s;
{
	return 0;
}

/* the following routine is from os/vfs_vnode.c */
void
vattr_null(vap)
struct vattr *vap;
{
        register int n;
        register char *cp;

        n = sizeof (struct vattr);
        cp = (char *)vap;
        while (n--) {
                *cp++ = -1;
        }
}


/* taken from nfs/nfs_common.c */
vattr_to_nattr(vap, na)
        register struct vattr *vap;
        register struct nfsfattr *na;
{

        na->na_type = (enum nfsftype)vap->va_type;
        na->na_mode = vap->va_mode;
        na->na_uid = vap->va_uid;
        na->na_gid = vap->va_gid;
        na->na_fsid = vap->va_fsid;
        na->na_nodeid = vap->va_nodeid;
        na->na_nlink = vap->va_nlink;
        na->na_size = vap->va_size;
        na->na_atime.tv_sec  = vap->va_atime.tv_sec;
        na->na_atime.tv_usec = vap->va_atime.tv_usec;
        na->na_mtime.tv_sec  = vap->va_mtime.tv_sec;
        na->na_mtime.tv_usec = vap->va_mtime.tv_usec;
        na->na_ctime.tv_sec  = vap->va_ctime.tv_sec;
        na->na_ctime.tv_usec = vap->va_ctime.tv_usec;
        na->na_rdev = vap->va_rdev;
        na->na_blocks = vap->va_blocks;
        na->na_blocksize = vap->va_blocksize;

        /*
         * This bit of ugliness is a *TEMPORARY* hack to preserve the
         * over-the-wire protocols for named-pipe vnodes.  It remaps the
         * VFIFO type to the special over-the-wire type. (see note in nfs.h)
         *
         * BUYER BEWARE:
         *  If you are porting the NFS to a non-SUN server, you probably
         *  don't want to include the following block of code.  The
         *  over-the-wire special file types will be changing with the
         *  NFS Protocol Revision.
         */
        if (vap->va_type == VFIFO)
                NA_SETFIFO(na);
}


int cractive = 0;               /* number of active ucred's */
int crallocsz = 0x30;           /* number of ucred's to allocate at a time */
struct ucred *crfreelist=NULL;  /* ucred free list */

/*
 * Allocate a zeroed cred structure and crhold it.
 */
struct ucred *
crget()
{
        register struct ucred *cr;

        cr = (struct ucred *)kmem_fast_alloc((caddr_t *)&crfreelist,
            sizeof (*cr), crallocsz);
        bzero((caddr_t)cr, sizeof (*cr));
        crhold(cr);
        cractive++;
        return (cr);
}

/*
 * Free a cred structure.
 * Throws away space when ref count gets to 0.
 */
void
crfree(cr)
        struct ucred *cr;
{

        if (--cr->cr_ref != 0)
                return;
        kmem_fast_free((caddr_t *)&crfreelist, (caddr_t)cr);
        cractive--;
}


/*
 * Duplicate cred structure to a new held one.
 */
struct ucred *
crdup(cr)
        struct ucred *cr;
{
        struct ucred *newcr;

        newcr = crget();
        *newcr = *cr;                   /* structure copy */
        newcr->cr_ref = 1;
        return (newcr);
}


/*
 * Return the (held) credentials for the current running process.
 */
struct ucred *
crgetcred()
{

	crhold(u.u_cred);
	return (u.u_cred);
}



int nfstsize()
{
	return IETSIZE;   
/*	return ECTSIZE; */
}


/*
 * Make an fhandle from a vnode
 */
/* ARGSUSED */

/*
 * Make an fhandle from a vnode
 */
makefh(fh, vp, exi)
	register fhandle_t *fh;
	struct vnode *vp;
	struct exportinfo *exi;
{
	USES_NVOP_FID;
	struct fid *fidp;
	int error;

	error = NVOP_FID(vp, &fidp);
	if (error || fidp == NULL) {
		/*
		 * Should be something other than EREMOTE
		 */
		return (EREMOTE);
	}
	if (fidp->fid_len + exi->exi_fid->fid_len + sizeof(fsid_t) 
		> NFS_FHSIZE) 
	{
		freefid(fidp);   /* definition changed above (in OOK) */
		return (EREMOTE);
	}
	bzero((caddr_t) fh, sizeof(*fh));
	fh->fh_fsid.val[0] = vp->v_vfsp->vfs_fsid.val[0];
	fh->fh_fsid.val[1] = vp->v_vfsp->vfs_fsid.val[1];
	fh->fh_len = fidp->fid_len;
	bcopy(fidp->fid_data, fh->fh_data, fidp->fid_len);
	fh->fh_xlen = exi->exi_fid->fid_len;
	bcopy(exi->exi_fid->fid_data, fh->fh_xdata, fh->fh_xlen);
#ifdef NFSDEBUG
	dprint(nfsdebug, 4, "makefh: vp %x fsid %x %x len %d data %d %d\n",
		vp, fh->fh_fsid.val[0], fh->fh_fsid.val[1], fh->fh_len,
		*(int *)fh->fh_data, *(int *)&fh->fh_data[sizeof(int)]);
#endif
	freefid(fidp);    /* definition changed above (in OOK) */
	return (0);
}



#define LOGBBY 3
#define MAJOR_MIN 128
#define MAJOR_MAX 255
#define NUM_MAJOR (MAJOR_MAX - MAJOR_MIN + 1)
#define MAJOR_MAPSIZE (NUM_MAJOR/NBBY)

/*
 * Set and return the first free position from the bitmap "map".
 * Return -1 if no position found.
 */
int
vfs_getnum(map, mapsize)
	register char *map;
	int mapsize;
{
	register int i;
	register char *mp;

	for (mp = map; mp < &map[mapsize]; mp++) {
		if (*mp != (char)0xff) {
			for (i=0; i < NBBY; i++) {
				if (!((*mp >> i) & 0x1)) {
					*mp |= (1 << i);
					return ((mp - map) * NBBY  + i);
				}
			}
		}
	}
	return (-1);
}

/*
 * Clear the designated position "n" in bitmap "map".
 */
void
vfs_putnum(map, n)
	register char *map;
	int n;
{

	if (n >= 0)
		map[n >> LOGBBY] &= ~(1 << (n - ((n >> LOGBBY) << LOGBBY)));
}


int
vfs_fixedmajor(vfsp)
	struct vfs *vfsp;
{
	return  0xfeed;   /* just some random number, ook this shouldn't matter */
}



static struct vfs *singlevfs;

int
vfs_add(vp, vfsp, flags)
	struct vnode *vp;
	struct vfs *vfsp;
	int flags;
{
	singlevfs = vfsp;
	return 0;
}

struct vfs *
getvfs()
{
	return singlevfs;
}



struct vnode *
fhtovp(fh, exi)
	fhandle_t *fh;
	struct exportinfo *exi;
{
	register struct vfs *vfsp;
	struct vnode *vp;
	int error;

	vfsp = getvfs(&fh->fh_fsid);
	if (vfsp == NULL) {
		return (NULL);
	}
	error = VFS_VGET(vfsp, &vp, (struct fid *)&(fh->fh_len));
	if (error || vp == NULL) {
#ifdef NFSDEBUG
		dprint(nfsdebug, 1, "fhtovp(%x) couldn't vget\n", fh);
#endif
		return (NULL);
	}
	return (vp);
}


/*ARGSUSED*/
/*
 * We fake up a simple export structure.
 */
struct exportinfo *
findexport(fsid, fid)
        fsid_t *fsid;
        struct fid *fid;
{
	static struct exportinfo exi;
	static int inited = 0;
	static struct fid exi_fid;
	int number;

	if (!inited) {
		inited = 1;
		exi.exi_fid = &exi_fid;
		exi.exi_next = NULL;
		exi_fid.fid_len = 4;
		number = 1;
		bcopy (&number, exi_fid.fid_data, sizeof(int));
/*		*(int*)exi_fid.fid_data = 1; --- SPARC alignment problems */
	};
        return &exi;
}


/*ARGSUSED */
hostinlist(sa, addrs)
        struct sockaddr *sa;
        struct exaddrlist *addrs;
{
	return 0;
}


/*ARGSUSED*/
void
sleep(ptr, priority)
	caddr_t ptr;
	int priority;
{
}

void
/*ARGSUSED*/
wakeup(ptr)
	caddr_t ptr;
{
}

/*
 * A somewhat more complete version of uiomove.
 *   -JSH 10-Apr-90
 */
uiomove(cp, n, rw, uio)
        register caddr_t cp;
        register int n;
        enum uio_rw rw;
        register struct uio *uio;
{
        register struct iovec *iov;
        u_int cnt;
        int error = 0;

        while (n > 0 && uio->uio_resid) {
                iov = uio->uio_iov;
                cnt = iov->iov_len;
                if (cnt == 0) {
                        uio->uio_iov++;
                        uio->uio_iovcnt--;
                        continue;
                }
                if (cnt > n)
                        cnt = n;
#if 0
                switch (uio->uio_segflg) {

                case UIO_USERSPACE:
                case UIO_USERISPACE:
                        if (rw == UIO_READ)
                                error = copyout(cp, iov->iov_base, cnt);
                        else
                                error = copyin(iov->iov_base, cp, cnt);
                        if (error)
                                return (error);
                        break;

                case UIO_SYSSPACE:
                        if (rw == UIO_READ)
                                error = kcopy((caddr_t)cp, iov->iov_base, cnt);
                        else
                                error = kcopy(iov->iov_base, (caddr_t)cp, cnt);
                        if (error)
                                return (error);
                        break;
                }
#else   /* all our stuff is in one address space */
                if (rw == UIO_READ)
			bcopy((caddr_t)cp, iov->iov_base, cnt);
		else
			bcopy(iov->iov_base, (caddr_t)cp, cnt);
#endif
                iov->iov_base += cnt;
                iov->iov_len -= cnt;
                uio->uio_resid -= cnt;
                uio->uio_offset += cnt;
                cp += cnt;
                n -= cnt;
        }
        return (error);
}

struct vnode *
dnlc_lookup(dvp, namep, cred)
	struct vnode *dvp;
	char *namep;
	struct ucred *cred;
{
	return (struct vnode *)NULL;
}


dnlc_enter(dvp, namep, cred)
	struct vnode *dvp;
	char *namep;
	struct ucred *cred;
{
}

dnlc_remove(dvp, namep)
	struct vnode *dvp;
	char *namep;
{
}

dnlc_purge()
{
}

#ifdef FL_LAYER
/*
 * This function returns a flnode with a given ffsh, used in fhtovp
 */
int
flgetvp(ffshp, type, flpp)
        struct ffshandle *ffshp;
	flnode_t type;
        struct flnode **flpp;

{
	USES_FVOP_FIDLOOK;
        struct vnode *vp;
        struct flnode *fl;
	struct flnode *rflp;
        int error=0;
	struct flnode *flfind();
	struct vfs *vfsp;
        struct flnode *flproot = FLPROOT(ffshp);

	*flpp = NULL;   /* in case of error */
        if ((fl = flfind(ffshp,type)) == NULL ||
            FLTOFFSH(fl)->ffsh_replid != ffshp->ffsh_replid) {
		switch (type) {
		case FL_STANDARD:
		case FL_RAW:
			if (error = fllook_repl(flproot, ffshp->ffsh_replid, &rflp))
				return error;   /* couldn't get desired root */
			if (error = FVOP_FIDLOOK(rflp->fl_vp, ffshp, &vp, NOCRED))
				return error;
			vfsp = NULL;
			break;
		case FL_CONTROL:
			vp = NULL;
			vfsp = (struct vfs *)ffshp->ffsh_fileid.a;
			ffshp->ffsh_fileid.a = 0;
			break;
		case FL_DUMMY:
			break;
		default:
			panic ("flgetvp: Bad fl type.\n");
		}

                error = flget(vp, &fl, vfsp, NOCRED, type);
        }

        if(!error)
                *flpp = fl;
        return (error);
}
#endif FL_LAYER



/*
 * Open/create a vnode.
 * This uses tricks of the new ook vn interface.
 */
int
vn_open(pnamep, seg, filemode, createmode, vpp)
	char *pnamep;
	register int filemode;
	int createmode;
	struct vnode **vpp;
{
	struct vnode *vp;		/* ptr to file vnode */
	register int mode;
	register int error;
	extern int errno;
	int fd;

	mode = 0;
	if (filemode & FREAD)
		mode |= VREAD;
	if (filemode & (FWRITE | FTRUNC))
		mode |= VWRITE;

	if (filemode & FCREAT) {
		panic ("Create not implemented.\n");
	} else {
		/*
		 * Wish to open a file.
		 * Just call the kernel.
		 */
		if (-1==(fd = open(pnamep, O_RDONLY)))
			return errno;
		/*
		 * Build a utok node for it.
		 */
		if (error = makeutoknode ((struct vnode*)fd, vpp))
			return error;
	};
	return 0;
}



/*
 * read or write a vnode
 */
int
vn_rdwr(rw, vp, base, len, offset, seg, ioflag, aresid)
	enum uio_rw rw;
	struct vnode *vp;
	caddr_t base;
	int len;
	int offset;
	int seg;
	int ioflag;
	int *aresid;
{
	USES_NVOP_RDWR;
	struct uio auio;
	struct iovec aiov;
	int error;

#if 0
	if ((rw == UIO_WRITE) && isrofile(vp)) {
		return (EROFS);
	}
#endif

	aiov.iov_base = base;
	aiov.iov_len = len;
	auio.uio_iov = &aiov;
	auio.uio_iovcnt = 1;
	auio.uio_offset = offset;
	auio.uio_segflg = seg;
	auio.uio_resid = len;
	error = NVOP_RDWR(vp, &auio, rw, ioflag, NULL);  /* kernel will fill in u.u_cred */
	if (aresid)
		*aresid = auio.uio_resid;
	else
		if (auio.uio_resid)
			error = EIO;
	return (error);
}

struct vnode *
makenfsnode()
{
	panic("Makenfsnode called ook.\n");
}


/*
 * Print a file handle
 */
printfhandle(fh)
	caddr_t fh;
{
	int i;
	int fhint[NFS_FHSIZE / sizeof (int)];

	bcopy(fh, (caddr_t)fhint, sizeof (fhint));
	for (i = 0; i < (sizeof (fhint) / sizeof (int)); i++) {
		printf("%x ", fhint[i]);
	}
}





/*
 * Open/create a vnode.
 * This uses tricks of the new ook vn interface.
 */
int
ook_vn_open(pnamep, vpp)
	char *pnamep;
	struct vnode **vpp;
{
	extern int errno;
	int error;
	int fd;

	/*
	 * Wish to open a file.
	 * Just call the kernel.
	 */
	if (-1==(fd = open(pnamep, O_RDONLY)))
		return errno;

	/*
	 * fd of zero is confused with a null vnode pointer.
	 * Just hope this error doesn't happen.
	 */
	if (fd==0) {
		printf ("Internal problem in vn_open.\n");
		exit (1);
	};

	*vpp = (struct vnode*)fd;
	return 0;
}


int
ook_vn_close(vp)
	struct vnode *vp;
{
	close ((int) vp);
	return 0;
}


int
copyin(src, dest, count)
	caddr_t src, dest;
	int count;
{
	bcopy (src, dest, count);
	return 0;
}


#include <varargs.h>
#include <vfork.h>



#define	MAXLINE	1024			/* max message size */
#define	NULL	0			/* manifest */

#define	PRIMASK(p)	(1 << ((p) & LOG_PRIMASK))
#define	PRIFAC(p)	(((p) & LOG_FACMASK) >> 3)
#define	IMPORTANT 	LOG_ERR

static char	*logname = "/dev/log";
static char	*ctty = "/dev/console";

static struct _syslog {
	int	_LogFile;
	int	_LogStat;
	char	*_LogTag;
	int	_LogMask;
	struct 	sockaddr _SyslogAddr;
	char	*_SyslogHost;
	int	_LogFacility;
} *_syslog;
#define	LogFile (_syslog->_LogFile)
#define	LogStat (_syslog->_LogStat)
#define	LogTag (_syslog->_LogTag)
#define	LogMask (_syslog->_LogMask)
#define	SyslogAddr (_syslog->_SyslogAddr)
#define	SyslogHost (_syslog->_SyslogHost)
#define	LogFacility (_syslog->_LogFacility)

extern	int errno, sys_nerr;
extern	char *sys_errlist[];

extern char *calloc();
extern time_t time();
extern unsigned int alarm();

static int
allocstatic()
{
	_syslog = (struct _syslog *)calloc(1, sizeof (struct _syslog));
	if (_syslog == 0)
		return (0);	/* can't do it */
	LogFile = -1;		/* fd for log */
	LogStat	= 0;		/* status bits, set by openlog() */
	LogTag = "syslog";	/* string to tag the entry with */
	LogMask = 0xff;		/* mask of priorities to be logged */
	LogFacility = LOG_USER;	/* default facility code */
	return (1);
}

/*VARARGS2*/
syslog(pri, fmt, va_alist)
	int pri;
	char *fmt;
	va_dcl
{
	va_list ap;

	va_start(ap);
	vsyslog(pri, fmt, ap);
	va_end(ap);
}

vsyslog(pri, fmt, ap)
	int pri;
	char *fmt;
	va_list ap;
{
	char buf[MAXLINE + 1], outline[MAXLINE + 1];
	register char *b, *f, *o;
	register int c;
	long now;
	int pid, olderrno = errno;

	if (_syslog == 0 && !allocstatic())
		return;
	/* see if we should just throw out this message */
	if (pri <= 0 || PRIFAC(pri) >= LOG_NFACILITIES ||
	    (PRIMASK(pri) & LogMask) == 0)
		return;
	if (LogFile < 0)
		openlog(LogTag, LogStat | LOG_NDELAY, 0);

	/* set default facility if none specified */
	if ((pri & LOG_FACMASK) == 0)
		pri |= LogFacility;

	/* build the message */
	o = outline;
	(void)sprintf(o, "<%d>", pri);
	o += strlen(o);
#if 0
	(void)time(&now);
#else
{
	struct timeval tv;
	gettimeofday(&tv, NULL);
	now = tv.tv_sec;
}
#endif
	(void)sprintf(o, "%.15s ", ctime(&now) + 4);
	o += strlen(o);
	if (LogTag) {
		(void)strcpy(o, LogTag);
		o += strlen(o);
	}
	if (LogStat & LOG_PID) {
		(void)sprintf(o, "[%d]", getpid());
		o += strlen(o);
	}
	if (LogTag) {
		(void)strcpy(o, ": ");
		o += 2;
	}

	b = buf;
	f = fmt;
	while ((c = *f++) != '\0' && c != '\n' && b < &buf[MAXLINE]) {
		if (c != '%') {
			*b++ = c;
			continue;
		}
		if ((c = *f++) != 'm') {
			*b++ = '%';
			*b++ = c;
			continue;
		}
		if ((unsigned)olderrno > sys_nerr)
			(void)sprintf(b, "error %d", olderrno);
		else
			(void)strcpy(b, sys_errlist[olderrno]);
		b += strlen(b);
	}
	*b++ = '\n';
	*b = '\0';
	(void)vsprintf(o, buf, ap);
	c = strlen(outline);
	if (c > MAXLINE)
		c = MAXLINE;

	/* output the message to the local logger */
	if (sendto(LogFile, outline, c, 0, &SyslogAddr, sizeof SyslogAddr) >= 0)
		return;
	if (!(LogStat & LOG_CONS))
		return;

	/* output the message to the console */
	pid = vfork();
	if (pid == -1)
		return;
	if (pid == 0) {
		int fd;

		(void)signal(SIGALRM, SIG_DFL);
		(void)sigsetmask(sigblock(0) & ~sigmask(SIGALRM));
		(void)alarm(5);
		fd = open(ctty, O_WRONLY);
		(void)alarm(0);
		(void)strcat(o, "\r");
		o = index(outline, '>') + 1;
		(void)write(fd, o, c + 1 - (o - outline));
		(void)close(fd);
		_exit(0);
	}
	if (!(LogStat & LOG_NOWAIT))
		while ((c = wait((int *)0)) > 0 && c != pid)
			;
}

/*
 * OPENLOG -- open system log
 */

openlog(ident, logstat, logfac)
	char *ident;
	int logstat, logfac;
{
	if (_syslog == 0 && !allocstatic())
		return;
	if (ident != NULL)
		LogTag = ident;
	LogStat = logstat;
	if (logfac != 0)
		LogFacility = logfac & LOG_FACMASK;
	if (LogFile >= 0)
		return;
	SyslogAddr.sa_family = AF_UNIX;
	(void)strncpy(SyslogAddr.sa_data, logname, sizeof SyslogAddr.sa_data);
	if (LogStat & LOG_NDELAY) {
		LogFile = socket(AF_UNIX, SOCK_DGRAM, 0);
		(void)fcntl(LogFile, F_SETFD, 1);
	}
}

/*
 * CLOSELOG -- close the system log
 */

closelog()
{

	if (_syslog == 0)
		return;
	(void) close(LogFile);
	LogFile = -1;
}

/*
 * SETLOGMASK -- set the log mask level
 */
setlogmask(pmask)
	int pmask;
{
	int omask;

	if (_syslog == 0 && !allocstatic())
		return (-1);
	omask = LogMask;
	if (pmask != 0)
		LogMask = pmask;
	return (omask);
}
