
/*-
 *
 * null_node.h
 *
 *	$Id: null_node.h,v 1.15 1994/09/26 18:55:18 johnh Exp $ (UCLA Ficus Project) $Date: 1994/09/26 18:55:18 $
 *
 * Copyright (c) 1992-1994 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#ifdef SVCM_TWO
#define USE_SVCM_DNLC
#define NON_SVCM_LOWER_LAYER
#endif   /* SVCM_TWO */


struct null_node {
	struct null_node *null_next;/* nullvn chain--for finding active nodes */
        struct vnode     null_vnode;    	/* our vnode */
        struct vnode	 *null_lowervp; 	/* lower level vnode */
	u_int		 null_flags;
#ifdef SVCM_TWO
	struct svcm_name *null_name;
#endif /* SVCM_TWO */
};

#define NULL_DIEING	0x00000004   /* null node is becoming inactive */
#define NULL_REBORN	0x00000008   /* someone wants to aquire a dieing node */

#define NULLTOV(np)     (&((np)->null_vnode))
#define VTONULL(vp)     ((struct null_node *)((vp)->v_data))
#define NULLTOLOWERV(np) ((np)->null_lowervp)

/* grab prototypes */
#include <nullfs/null_subr.h>
#include <nullfs/null_vnodeops.h>
#include <nullfs/null_vfsops.h>
#include <nullfs/null_debug.h>

